
screw_xdist		= 187;	// distance between screws
screw_margin	= 5;	// distance between screw centre and edge of plastic
screw_dia		= 4.5;	// screw diameter
screw_slot		= 8;	// screw slot length

thickness		= 4;	// baseplate thickness

clockback_thicc = 4;	// clock backplate thickness

tang_width		= 12;	// clock mounting tang width
tang_length		= 17;	// clock mounting tang length

// constants
FUDGE = 0.01;
$fn=100;

// calculated values
TWIDTH = screw_xdist + (screw_margin * 2);
THEIGHT = (screw_margin * 2) + tang_length + thickness;


module screwslot(dia, length)
{
	slotx = length - dia;
	
	if (length == dia) {
		cylinder(d=screw_dia, h=thickness+(2*FUDGE));
	} else {
		translate([-slotx/2, 0, 0]) cylinder(d=screw_dia, h=thickness+(2*FUDGE));
		translate([slotx/2, 0, 0]) cylinder(d=screw_dia, h=thickness+(2*FUDGE));
		translate([-slotx/2, -screw_dia/2, 0]) cube([slotx, screw_dia, thickness+(2*FUDGE)]);
	}
}


// backplate, screws and corner gaps
difference() {
	union() {
		// backplate
		cube([TWIDTH, THEIGHT, thickness]);
		
		translate([screw_margin, screw_margin, 0]) cylinder(d=screw_dia*5, h=thickness);
		translate([screw_margin+screw_xdist, screw_margin, 0]) cylinder(d=screw_dia*5, h=thickness);
	}
	
	// screw holes
	// left
	translate([screw_margin, screw_margin, -FUDGE]) rotate([0,0,90]) screwslot(dia=screw_dia, length=screw_slot);
	// right
	translate([screw_margin+screw_xdist, screw_margin, -FUDGE]) screwslot(dia=screw_dia, length=screw_slot);

	// corner points
	translate([-FUDGE, THEIGHT-tang_length+FUDGE, -FUDGE]) cube([tang_width, tang_length, thickness+(FUDGE*2)]);
	translate([TWIDTH-tang_width+FUDGE, THEIGHT-tang_length+FUDGE, -FUDGE]) cube([tang_width, tang_length, thickness+(FUDGE*2)]);
};

// tab, left side
translate([0, THEIGHT-tang_length-thickness, 0]) {
	// vertical
	cube([tang_width, thickness, (thickness*2)+clockback_thicc+FUDGE]);
	
	// horizontal
	translate([0, 0, thickness+clockback_thicc]) cube([tang_width, tang_length+thickness, thickness]);
}

// tab, left side
translate([TWIDTH-tang_width, THEIGHT-tang_length-thickness, 0]) {
	// vertical
	cube([tang_width, thickness, (thickness*2)+clockback_thicc+FUDGE]);
	
	// horizontal
	translate([0, 0, thickness+clockback_thicc]) cube([tang_width, tang_length+thickness, thickness]);
}